//****************************************************************
// Commad line	15puzzle Optimal Solver by takaken 09/2024
//****************************************************************
#include <stdio.h>
#include <stdlib.h>
#include <omp.h>
#include <time.h>

#define  FALSE	  0
#define  TRUE	  1

// \o[
#include "15puz20solver.c"

int main(void)
{
	int  i;
	clock_t st;

	//---------------------------------------------
	// Tvݒ
	//---------------------------------------------
	int  sample1[BOARD_SIZE] = {  // <-ȒP
	 1, 2, 3, 4,
	 5, 6, 0, 7,
	 9,10,11, 8,
	13,14,15,12
	};
	int  sample2[BOARD_SIZE] = {  // <-
	15,11, 4, 0,
	12,14, 7, 9,
	 8,10, 6, 2,
	13, 3, 5, 1
	};
	int  sample3[BOARD_SIZE] = {  // <-80
	 0,12, 9,13,
	15,11,10,14,
	 3, 7, 2, 5,
	 4, 8, 6, 1
	};
	int  sample4[BOARD_SIZE] = {  // <-1
	 0,12, 8, 4,
	15,11, 7, 3,
	14,10, 6, 2,
	13, 9, 5, 1
	};
	int  sample5[BOARD_SIZE] = {  // <-2
	 1, 5, 9,13,
	 2, 6,10,14,
	 3, 7,11,15,
	 4, 8,12, 0
	};
	for (i = 0; i < BOARD_SIZE; i++)
		BOARD[i] = sample2[i];	// sample? ( ?ύX )

	//---------------------------------------------
	// PDB [m
	//---------------------------------------------
	PDB1 = (char*)malloc(PDB_SIZE);
	PDB2 = (char*)malloc(PDB_SIZE);

	//---------------------------------------------
	// nCrZoe[u쐬 (PDBf[^x[Xp)
	//---------------------------------------------
	printf("Making nCr\n");
	MakeCombin();

	//---------------------------------------------
	// PDBe[u
	//---------------------------------------------
	printf("Making PDB1\n");
	MAX_PDB1 = MakePDB(PDB1, PATTERN1);

	printf("Making PDB2\n");
	MAX_PDB2 = MakePDB(PDB2, PATTERN2);

	//---------------------------------------------
	// WDe[u
	//---------------------------------------------
	printf("Making WD\n");
	MakeWDDB();

	// {[h\
	printf("####### Problem #######\n");
	for (i = 0; i < BOARD_SIZE; i++) {
		if (i && !(i % 4)) printf("\n");
		printf("%3d", BOARD[i]);
	}
	printf("\n");

	// TJn
	printf("######## START ########\n");
	st = clock();

	//---------------------------------------------
	// 
	//---------------------------------------------
	RESULT = PreSearch();

	// T\
	printf("WD=%d, PDB=%d, Threads=%d/%d\n", START_WD, START_PDB, USE_THREADS, MAX_THREADS);

	//---------------------------------------------
	// OpenMPT (ŉĂȂ)
	//---------------------------------------------
	if (RESULT == FALSE) OmpSearch();

	// ʕ\
	if (RESULT == UNSOLVE) {
		printf("UnSolvale.\n");
	}
	else {
		// MOVES\
		printf("Optimal solution is %d moves.\n", MOVES);

		// sԕ\
		printf("Used time: %.2f sec\n", (double)(clock() - st) / CLOCKS_PER_SEC);

		// TRACE[]\
		printf("Solution:\n");
		for (i = 0; i < MOVES; i++) {
			printf("%3d", TRACE[i]);
			if (i % 10 == 9) printf("\n");
		}
		printf("\n");
	}

	//---------------------------------------------
	// PDB [
	//---------------------------------------------
	free(PDB1);
	free(PDB2);

	return 0;
}
