//****************************************************************
// 15puzzle Optimal Solver Code v2.0 by takaken 		09/2024
//****************************************************************
//		 FALSE	  0
//		 TRUE	  1
#define  UNSOLVE  2
#define  SOLVED   3
#define  CANCEL   4

#define  BOARD_SIZE 	16	// {[h̃TCY(4~4)
#define  MAX_MOVES		82	// z肳萔̍ől
#define  START_SIZE   1000	// OpenMPpTCY

// WD
#define  WDTBL_SIZE  25000	// Walking Distance Table Size

// PDB
#define  PDB_SIZE 12108096	// 16 * 15C5 * 10C5
#define  TBLSIZE	378378	// (PDB_SIZE - 1) / 32 + 1

//****************************************************************
// ͏
int  BOARD[BOARD_SIZE];

// o͏ (Solver)
int  RESULT;				// UNSOLVE, SOLVED, CANCEL
int  MOVES; 				// ŒZ萔
int  TRACE[MAX_MOVES];		// 菇L^

// o͏ ({)
int  MAX_THREADS;			// PC̍őXbh
int  USE_THREADS;			// gpXbh
int  START_WD;				// JnWD
int  START_PDB; 			// JnPDB

//****************************************************************

typedef  unsigned int		u32;
typedef  unsigned __int64	u64;

// ړ\ȑI̐
int  MOVAL_N[BOARD_SIZE] = {
	2, 3, 3, 2,
	3, 4, 4, 3,
	3, 4, 4, 3,
	2, 3, 3, 2
};

// ړ\ʒue[u
int  MOVAL_S[BOARD_SIZE][4] = {
  1,  4,  0,  0,
  2,  5,  0,  0,
  3,  6,  1,  0,
  7,  2,  0,  0,
  0,  5,  8,  0,
  1,  6,  9,  4,
  2,  7, 10,  5,
  3, 11,  6,  0,
  4,  9, 12,  0,
  5, 10, 13,  8,
  6, 11, 14,  9,
  7, 15, 10,  0,
  8, 13,  0,  0,
  9, 14, 12,  0,
 10, 15, 13,  0,
 11, 14,  0,  0
};

//--------------------------------------------------------
// WDf[^x[X
//--------------------------------------------------------
typedef struct wd {
	u64  bitmap;		// ǖʃp^[(bit`)
	int  moves; 		// 萔
	struct wd* up[4];	// N
	struct wd* down[4]; // N
} wd_t;
wd_t WD_DB[WDTBL_SIZE];
wd_t* WDTOP, * WDEND;
int  TABLE[4][4];

//--------------------------------------------------------
// PDBf[^x[Xp nCr Zoe[u
//--------------------------------------------------------
int  COMBIN[BOARD_SIZE][6]; 	// pXJ̎Op`
int  COMBIN1[BOARD_SIZE][6];	// @V@n=1p
int  COMBIN2[BOARD_SIZE][6];	// @V@n=2p

//--------------------------------------------------------
// PDBf[^x[X
//--------------------------------------------------------
int  PATTERN1[BOARD_SIZE] = {	// p^[`
	3, 1, 1, 1,
	2, 3, 3, 1,
	2, 3, 3, 1,
	2, 2, 2, 0
};
char *PDB1; 					// p^[ca
int  MAX_PDB1;					// PDBl̍ől
int  CONV1[] = {0,3,1,1,1,2,3,3,1,2,3,3,1,2,2,2};// s[XԍPATTERNlɕϊ

int  PATTERN2[BOARD_SIZE] = {
	1, 1, 1, 3,
	1, 3, 3, 2,
	1, 3, 2, 2,
	3, 2, 2, 0
};
char *PDB2;
int  MAX_PDB2;
int  CONV2[] = {0,1,1,1,3,1,3,3,2,1,3,2,2,3,2,2};

//--------------------------------------------------------
// PreSearch (OpenMPJnn_)
//--------------------------------------------------------
u64  FinishBoard;				// `rbg
u64  StartBoard[START_SIZE];	// {[h̃rbg\
int  StartPrevP[START_SIZE];	// OɓR}̈ʒu
int  StartPrevS[START_SIZE];	// eǖʂ̃CfbNX
int  StartMoves[START_SIZE];	// 萔
int  STT, END;
int  START_M;		// Jnn_moves
int  START_A;		// Jnn_Xg̍ŏ
int  START_B;		// Jnn_Xg̍Ō

//****************************************************************
// DTWDe[u
//****************************************************************
// Ԃrbgɂ
u64 TableToBitmap(void)
{
	int  pos, group;
	u64  bitmap;

	bitmap = 0;
	for (pos = 0; pos < 4; pos++)
		for (group = 0; group < 4; group++)
			bitmap = (bitmap << 3) | TABLE[pos][group];
	return bitmap;
}
// rbg񂩂Ԃ𕜌
int  BitmapToTable(u64 bitmap)
{
	int  pos, group, piece, space;

	for (pos = 3; pos >= 0; pos--) {
		piece = 0;
		for (group = 3; group >= 0; group--) {
			TABLE[pos][group] = (int)(bitmap & 7);
			bitmap >>= 3;
			piece += TABLE[pos][group];
		}
		if (piece == 3) space = pos;
	}
	return space;	// 󂫃}Ẍʒu
}
// ԂWDDBɕۑ
wd_t* WriteTablePos(int moves)
{
	wd_t* wdb2;
	u64  bitmap;

	// p^[̈ʒu(wdb2)jAT[`
	bitmap = TableToBitmap();
	for (wdb2 = WD_DB; wdb2 < WDEND; wdb2++)
		if (wdb2->bitmap == bitmap) break;

	// VKp^[o^
	if (wdb2 == WDEND) {
		WDEND->bitmap = bitmap;
		WDEND->moves = moves;
		WDEND++;
	}

	return wdb2;
}
// WDe[u
void MakeWDDB(void)
{
	int  pos, group, space, piece, moves;
	wd_t* wdb1;
	u64  bitmap;

	// (`)
	for (pos = 0; pos < 4; pos++)
		for (group = 0; group < 4; group++)
			TABLE[pos][group] = 0;
	TABLE[0][0] = 4;
	TABLE[1][1] = 4;
	TABLE[2][2] = 4;
	TABLE[3][3] = 3;

	// (`)o^
	WDTOP = WDEND = WD_DB;
	WDEND->bitmap = TableToBitmap();;
	WDEND->moves = 0;
	WDEND++;

	// DT
	while (WDTOP < WDEND) {
		// WDTOPTABLE[][]Ăяo
		bitmap = WDTOP->bitmap;
		moves = WDTOP->moves;
		wdb1 = WDTOP;
		WDTOP++;

		// bitmap -> TABLE[][]
		space = BitmapToTable(bitmap);

		// Ɉړ
		piece = space + 1;
		if (piece < 4) {
			for (group = 0; group < 4; group++) {
				if (TABLE[piece][group] == 0) continue;
				TABLE[piece][group]--;
				TABLE[space][group]++;
				wdb1->up[group] = WriteTablePos(moves + 1);
				TABLE[piece][group]++;
				TABLE[space][group]--;
			}
		}

		// Ɉړ
		piece = space - 1;
		if (piece >= 0) {
			for (group = 0; group < 4; group++) {
				if (TABLE[piece][group] == 0) continue;
				TABLE[piece][group]--;
				TABLE[space][group]++;
				wdb1->down[group] = WriteTablePos(moves + 1);
				TABLE[piece][group]++;
				TABLE[space][group]--;
			}
		}
	}
}
//****************************************************************
// DTPDBe[u
//****************************************************************
// ŏSnbV֐(pattern[]hashl߂)
int  PtnToHash(int pattern[])
{
	int  num, i, n1, n2, r1, r2;
	int  hash = 0, been = 11;	// 01, 15, 25 (v11)

	n1 = 14; r1 = 5;
	n2 = 9; r2 = 5;
	for (i = 0; been; i++) {
		num = pattern[i];
		if (num == 0) {
			hash += i;
			been--;
		}
		else {
			if (num == 1) {
				hash += COMBIN1[n1][r1--];
				been--;
			}
			else {
				if (num == 2) {
					hash += COMBIN2[n2][r2--];
					been--;
				}
				n2--;
			}
			n1--;
		}
	}

	return hash;
}
// ŏSnbVt֐(hashlpattern[]𕜌)
int  HashToPtn(int pattern[], int hash)
{
	int  i, c, n1, n2, r1, r2;
	int  h0, h1, h2;

	// hashl 0hashl, 1hashl, 2hashl ɕ
	h0 = hash % 16;   hash /= 16;	//	 16 = 16C1
	h1 = hash % 3003; hash /= 3003; // 3003 = 15C5
	h2 = hash;

	for (i = 0; i < BOARD_SIZE; i++) pattern[i] = 3;	// 0, 1, 2 ȊO
	pattern[h0] = 0;	// spaceʒu

	n1 = 14; r1 = 5;
	n2 = 9; r2 = 5;
	for (i = 0; i < BOARD_SIZE; i++) {
		if (pattern[i] == 0) continue;
		c = COMBIN[n1][r1];
		if (h1 >= c) {
			h1 -= c;
			r1--;
			pattern[i] = 1;
		}
		else {
			c = COMBIN[n2][r2];
			if (h2 >= c) {
				h2 -= c;
				r2--;
				pattern[i] = 2;
			}
			n2--;
		}
		n1--;
	}
	return h0;	// spaceʒuԂ
}
// DT (input[]	->	output[])
int SearchPDB(int pattern[],u32 samedb[], u32 input[], u32 output[], char pdb[], int moves)
{
	int count = 0, space, piece, n, i;
	int pos1, bit1, hash1, pos2, bit2, hash2;
	u32 bitmap1, bitmap2;

	// input[]Ăэ
	for (pos1 = 0; pos1 < TBLSIZE; pos1++) {
		bitmap1 = input[pos1];
		hash1 = pos1 << 5;
		for (bit1 = 0; bitmap1; bit1++, bitmap1 >>= 1) {
			if (!(bitmap1 & 1)) continue;
			space = HashToPtn(pattern, hash1 + bit1);

			// Vǖʐoutput[]֏o
			for (i = 0; i < MOVAL_N[space]; i++) {
				piece = MOVAL_S[space][i];		// ړ̈ʒu
				n = pattern[piece];
				pattern[space] = n;
				pattern[piece] = 0;
				hash2 = PtnToHash(pattern);
				pos2 = hash2 >> 5;
				bit2 = hash2 & 0x1F;
				bitmap2 = 1 << bit2;
				if (!(samedb[pos2] & bitmap2)) {
					samedb[pos2] |= bitmap2;
					output[pos2] |= bitmap2;
					pdb[hash2] = (char)moves;
					count++;
				}
				pattern[space] = 0;
				pattern[piece] = n;
			}
		}
	}
	return count;
}
// PDBe[u
int  MakePDB(char pdb[], int pattern[])
{
	int  i, count, hash, moves;
	u32  *samedb;	// ǖʌe[u
	u32  *check1;	// VǖʃtOe[u
	u32  *check2;	// VǖʃtOe[u

	// q[v[
	samedb = (u32*)malloc(TBLSIZE * sizeof(u32));
	check1 = (u32*)malloc(TBLSIZE * sizeof(u32));
	check2 = (u32*)malloc(TBLSIZE * sizeof(u32));

	// tOe[u
	for (i = 0; i < TBLSIZE; i++)
		samedb[i] = check1[i] = check2[i] = 0;

	// ^o^
	hash = PtnToHash(pattern);
	samedb[hash >> 5] = 1 << (hash & 0x1F);
	check1[hash >> 5] = 1 << (hash & 0x1F);
	pdb[hash] = 0;

	moves = 1;
	for (;;) {
		// check1 -> check2
		count = SearchPDB(pattern, samedb, check1, check2, pdb, moves);
		if (!count) break;
		moves++;
		for (i = 0; i < TBLSIZE; i++) check1[i] = 0;

		// check2 -> check1
		count = SearchPDB(pattern, samedb, check2, check1, pdb, moves);
		if (!count) break;
		moves++;
		for (i = 0; i < TBLSIZE; i++) check2[i] = 0;
	}

	// [
	free(samedb);
	free(check1);
	free(check2);

	return moves - 1;	// PDBl̍ől
}
//****************************************************************
// LowerBound߂铙̊֐
//****************************************************************
// PDBf[^x[XpnCrZoe[u쐬
void MakeCombin(void)
{
	int  n, r;

	// COMBIN[n][r] = nCr
	COMBIN[0][0] = 1;
	for (n = 1; n < BOARD_SIZE; n++) {
		for (COMBIN[n][0] = 1, r = 1; r <= 5; r++) {
			COMBIN[n][r] = COMBIN[n - 1][r - 1] + COMBIN[n - 1][r];
			COMBIN1[n][r] = COMBIN[n][r] * 16;			//	 16 = 16C1
			COMBIN2[n][r] = COMBIN[n][r] * 16 * 3003;	// 3003 = 15C5
		}
	}
}
// {[h݂̑𒲂ׂ
int  ParityCheck(int board[])
{
	int  i, j, space, inv;

	// 󂫃}Ẍʒu
	for (i = 0; i < BOARD_SIZE; i++)
		if (board[i] == 0) { space = i; break; }

	// ̑݃`FbNupYv_
	// rM.ؖΒj.yn.` 
	inv = 3 - space / 4;
	for (i = 0; i < BOARD_SIZE; i++) {
		if (board[i] == 0) continue;
		for (j = i + 1; j < BOARD_SIZE; j++)
			if (board[j] && board[j] < board[i]) inv++;
	}
	return (inv & 1) ? FALSE : TRUE;
}
// {[hWD(㉺)߂
wd_t* BoardToWD1(int board[])
{
	int   y, x, n, work[4];
	wd_t* wddb1;
	u64  bitmap;

	//  WD1(UP, DOWN)
	bitmap = 0;
	for (y = 0; y < 4; y++) {
		for (x = 0; x < 4; x++) work[x] = 0;
		for (x = 0; x < 4; x++) {
			n = board[y * 4 + x];
			if (n == 0) continue;
			work[(n - 1) / 4]++;
		}
		for (x = 0; x < 4; x++)
			bitmap = (bitmap << 3) | work[x];
	}
	for (wddb1 = WD_DB; wddb1->bitmap != bitmap; wddb1++);

	return wddb1;
}
// {[hWD(E)߂
wd_t* BoardToWD2(int board[])
{
	int   y, x, n, work[4];
	wd_t* wddb2;
	u64  bitmap;

	//  WD2(LEFT, RIGHT)
	bitmap = 0;
	for (x = 0; x < 4; x++) {
		for (y = 0; y < 4; y++) work[y] = 0;
		for (y = 0; y < 4; y++) {
			n = board[y * 4 + x];
			if (n == 0) continue;
			work[(n - 1) % 4]++;
		}
		for (y = 0; y < 4; y++)
			bitmap = (bitmap << 3) | work[y];
	}
	for (wddb2 = WD_DB; wddb2->bitmap != bitmap; wddb2++);

	return wddb2;
}
// PDB̎̐[߂
int  NextDepth(int depth, int max_depth, int pdb, int max_pdb)
{
	do {
		depth++;
		if (pdb < max_pdb) pdb++;
	} while ((depth + pdb) <= max_depth);

	return depth;
}
// {[hPDB߂
int  BoardToPDB(int board[], int *max_pdb)
{
	int  i, pdb1, pdb2;
	int  pattern1[BOARD_SIZE], pattern2[BOARD_SIZE];

	for (i = 0; i < BOARD_SIZE; i++) {
		pattern1[i] = CONV1[board[i]];
		pattern2[i] = CONV2[board[i]];
	}
	pdb1 = PDB1[PtnToHash(pattern1)];
	pdb2 = PDB2[PtnToHash(pattern2)];

	// PDB1 ̗p
	if (pdb1 > pdb2) {
		*max_pdb = MAX_PDB1;
		return pdb1;
	}
	// PDB2 ̗p
	*max_pdb = MAX_PDB2;
	return pdb2;
}
//****************************************************************
// OpenMPT 
//****************************************************************
// {[hrbgo
u64 BoardToBits(int board[])
{
	int  i;
	u64 bits = 0;

	for (i = 0; i < BOARD_SIZE; i++) {
		bits <<= 4;
		bits |= board[i];
	}
	return bits;
}
// rbg񂩂{[ho (spaceʒuԂ)
int  BitsToBoard(int board[], u64 bits)
{
	int  i, space;

	for (i = BOARD_SIZE - 1; i >= 0; i--) {
		board[i] = bits & 0xf;
		if (board[i] == 0) space = i;
		bits >>= 4;
	}
	return space;
}
// IDA*
int IDA(int board[], int space, int prevp, wd_t* wddb1o, wd_t* wddb2o, int depth, int max_depth, int next, int trace[])
{
	int  i, n, piece, diff, retc;
	int  wd, pdb, max_pdb;
	wd_t* wddb1, * wddb2;

	if (max_depth >= MOVES) return CANCEL;	// ŏ萔̍XVs

	// ̎𑍂ĎĂ݂
	depth++;
	for (i = 0; i < MOVAL_N[space]; i++) {
		piece = MOVAL_S[space][i];		// ړ̈ʒu
		if (piece == prevp) continue;	// O߂h~
		n = board[piece];				// ړ̐

		// ̈ړɂ莟ǖʂ(WD)߂
		diff = space - piece;	// diff = -4, -1, 1, 4
		if (diff > 0) {
			if (diff == 4) {
				wddb1 = wddb1o->down[(n - 1) >> 2]; // 
				wddb2 = wddb2o;
			}
			else {
				wddb1 = wddb1o;
				wddb2 = wddb2o->down[(n - 1) & 3];	// E
			}
		}
		else {
			if (diff == -4) {
				wddb1 = wddb1o->up[(n - 1) >> 2];		// 
				wddb2 = wddb2o;
			}
			else {
				wddb1 = wddb1o;
				wddb2 = wddb2o->up[(n - 1) & 3];		// 
			}
		}
		wd = wddb1->moves + wddb2->moves;
		if (depth + wd > max_depth) continue;

		// 𔭌
		if (wd == 0) {
			trace[depth - 1] = n;  // 𓚎菇L^
			return TRUE;
		}

		// l}@Ń`FbNĂċAďo
		if (depth + wd <= max_depth) {
			board[piece] = 0;
			board[space] = n;

			// PDB`FbN
			if (depth == next) {
				pdb = BoardToPDB(board, &max_pdb);
				next = (wd > pdb) ? MAX_MOVES : NextDepth(depth, max_depth, pdb, max_pdb);
			}
			else {
				pdb = 0;
			}

			if (pdb <= wd || (depth + pdb) <= max_depth) {
				retc = IDA(board, piece, space, wddb1, wddb2, depth, max_depth, next, trace);
			}
			else {
				retc = FALSE;
			}

			board[space] = 0;
			board[piece] = n;
			if (retc == TRUE) {
				trace[depth - 1] = n;  // 𓚎菇L^
				return TRUE;
			}
			if (retc == CANCEL) return CANCEL;
		}
	}

	return FALSE;
}
// OpenMPT
void OmpSearch(void)
{
	int  i, n, piece;

	// OpenMP gp錾
	omp_set_num_threads(USE_THREADS);
	#pragma omp parallel for
	for (i = START_A; i <= START_B; i++) {
		int  j, k, space, prevp, wd, pdb, lowb, max_depth, max_pdb, next, retc;
		int  board[BOARD_SIZE], trace[MAX_MOVES];
		wd_t* wddb1, * wddb2;

		space = BitsToBoard(board, StartBoard[i]);
		prevp = StartPrevP[i];

		wddb1 = BoardToWD1(board);
		wddb2 = BoardToWD2(board);
		wd = wddb1->moves + wddb2->moves;
		pdb = BoardToPDB(board, &max_pdb);
		lowb = (wd > pdb) ? wd : pdb;

		retc = FALSE;
		for (max_depth = lowb; retc == FALSE; max_depth += 2) {
			next = (lowb == wd) ? MAX_MOVES : NextDepth(0, max_depth, pdb, max_pdb);

			retc = IDA(board, space, prevp, wddb1, wddb2, 0, max_depth, next, trace);
			if (retc == TRUE && max_depth < MOVES) {
				MOVES = max_depth;
				// TRACE[]쐬
				for (j = 0; j < max_depth; j++) TRACE[START_M + j] = trace[j];	// OMPT
				for (j = START_M - 1, k = i; j >= 0; j--, k = StartPrevS[k]) {	// 
					piece = StartPrevP[k];
					n = board[piece];
					TRACE[j] = n;
					board[piece] = 0;
					board[space] = n;
					space = piece;
				}
			}
		}
	}
	if (MOVES < 0) {	// Windowsł݂̂Ŕ
		MOVES = 0;
		RESULT = CANCEL;
	}
	else {
		MOVES += START_M;
		RESULT = SOLVED;
	}
}
//****************************************************************
// 
//****************************************************************
// ǖʓo^
int  PutStatus(u64	boardbits, int prevp, int moves, int stt)
{
	int  i;

	for (i = 0; i < END; i++)
		if (boardbits == StartBoard[i] && prevp == StartPrevP[i]) break;
	if (i < END) return TRUE;	// Vȋǖʂł͂Ȃ

	if (END == START_SIZE) return FALSE;
	if (USE_THREADS == MAX_THREADS) return FALSE;

	// Vǖʓo^
	StartBoard[END] = boardbits;
	StartPrevP[END] = prevp;
	StartPrevS[END] = stt - 1;
	StartMoves[END] = moves;
	END++;
	USE_THREADS++;

	return TRUE;
}
// 
int  PreSearch(void)
{
	int  i, j, k, n, space, piece, prevp, moves, max_pdb, select;
	int  board[BOARD_SIZE];
	u64  boardbits;
	wd_t* wddb1, * wddb2;

	// JnWD
	wddb1 = BoardToWD1(BOARD);
	wddb2 = BoardToWD2(BOARD);
	START_WD = wddb1->moves + wddb2->moves;

	// JnPDB
	START_PDB = BoardToPDB(BOARD, &max_pdb);

	// Xbh
	MAX_THREADS = omp_get_max_threads();
	USE_THREADS = 1;

	// ̑݃`FbN
	if (!ParityCheck(BOARD)) return UNSOLVE;	// ͖

	//----------------------------------------------------------------

	MOVES = MAX_MOVES;

	// `̃rbg
	for (i = 0; i < BOARD_SIZE; i++)
		board[i] = i + 1;
	board[BOARD_SIZE - 1] = 0;
	FinishBoard = BoardToBits(board);

	// Jnǖʓo^
	STT = END = 0;
	StartBoard[END] = BoardToBits(BOARD);
	StartPrevP[END] = -1;
	StartPrevS[END] = -1;
	StartMoves[END] = START_M = 0;
	END++;

	// ŏ犮Ă
	if (StartBoard[END - 1] == FinishBoard) {
		MOVES = 0;
		return SOLVED;	// 𔭌
	}

	// DT ()
	while (STT < END) {
		space = BitsToBoard(board, StartBoard[STT]);
		prevp = StartPrevP[STT];
		moves = StartMoves[STT] + 1;
		STT++;
		if (moves > START_M) {	// 萔オ
			START_M = moves;
			USE_THREADS = 0;
		}

		select = MOVAL_N[space];			// I̐
		for (i = 0; i < select; i++) {
			piece = MOVAL_S[space][i];		// ړ̈ʒu
			if (piece == prevp) continue;	// O߂h~
			n = board[piece];				// ړ̐

			board[piece] = 0;
			board[space] = n;
			boardbits = BoardToBits(board);
			if (boardbits == FinishBoard) { // ɉ𔭌
				// MOVES
				MOVES = moves;
				// TRACE[]
				TRACE[moves - 1] = n;
				for (j = moves - 2, k = STT - 1; j >= 0; j--, k = StartPrevS[k]) {
					piece = StartPrevP[k];
					n = board[piece];
					TRACE[j] = n;

					board[piece] = 0;
					board[space] = n;
					space = piece;
				}
				USE_THREADS = 1;
				return SOLVED;	// 𔭌
			}
			if (!PutStatus(boardbits, space, moves, STT)) break;	// I
			board[space] = 0;
			board[piece] = n;
		}
		if (i < select) break;	// I
	}

	// }`Xbḧ̗߂
	START_M = moves - 1;
	START_A = -1;
	USE_THREADS = 0;
	for (i = 0; i < END; i++) {
		if (StartMoves[i] == START_M) {
			USE_THREADS++;
			if (START_A == -1) START_A = i;
			START_B = i;
		}
	}

	return FALSE;	// ܂͌ĂȂ
}
